#ifndef ESP32_C3_UART_INTERFACE_H
#define ESP32_C3_UART_INTERFACE_H

#define C3_SYSTEM_PERIP_CLK_EN0_REG ((volatile uint32_t *)0x0010)
// SYSTEM_UART_MEM_CLK_EN is on 24
// SYSTEM_UARTn_CLK_EN n=0 is on 2, n=1 is on 5

#define C3_UART_CLKDIV_REG ((volatile uint32_t *)0x0014)
// UART_CLKDIV - integer part of baud rate calculator devisor - 0 to 11
// UART_CLKDIV_FRAG - numerator of devisor in baud rate calculator devisor

#define C3_UART_RX_FILT_REG ((volatile uint32_t *)0x0018)
// SYSTEM_UARTn_RST n=0 is on 2, n=1 is on 5

#define C3_UART_CONF0_REG ((volatile uint32_t *)0x0020)
// UART_PARITY is on 0
// UART_PARITY_EN is on 1
// UART_BIT_NUM is on 2 and 3

#define C3_UART_CLK_CONF_REG ((volatile uint32_t *)0x0078)
// UART_RST_CORE is on 23
// UART_SCLK_SEL is on 20 and 21 (2 bits), selcetion is between 1 and 3
// UART_SCLK_DIV_NUM - The integral part of the frequency divisor - 12 to 19
// UART_SCLK_DIV_A - The numerator of the frequency divisor - 6 to 11
// UART_SCLK_DIV_B - The denominator of the frequency divisor - 0 to 5

#define C3_UART_ID_REG ((volatile uint32_t *)0x0080)
// UART_UPDATE_CTRL is on 30
// UART_REG_UPDATE is on 31

void config_uart();
void init_uart();
void reset_uart();
void enable_uart_transmitter();

#endif